Module com.io7m.jregions.core
Package com.io7m.jregions.core.parameterized.areas

## Class PAreasI

- java.lang.Object
- - com.io7m.jregions.core.parameterized.areas.PAreasI

-     public final class PAreasI
      extends java.lang.Object

  Functions over areas.

  These functions operate using the concepts of minimum-x, maximum-x, minimum-y, and maximum-y edges. It is up to individual applications to assign meaning to these edges such as "left" for minimum-x and "top" for minimum-y.

- - ### Method Summary

    All Methods Static Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static <S> PAreaI<S>` | `alignCenter​(PAreaI<S> outer, PAreaI<S> inner)` | Align the area `inner` such that the center of the area is equal to the center of `outer`.
    `static <S> PAreaI<S>` | `alignHorizontallyCenter​(PAreaI<S> outer, PAreaI<S> inner)` | Deprecated. Use `alignOnXCenter(PAreaI, PAreaI)`
    `static <S> PAreaI<S>` | `alignHorizontallyMaxX​(PAreaI<S> outer, PAreaI<S> inner)` | Deprecated. Use `alignOnXMaxX(PAreaI, PAreaI)`
    `static <S> PAreaI<S>` | `alignHorizontallyMaxXOffset​(PAreaI<S> outer, PAreaI<S> inner, int offset)` | Deprecated. Use `alignOnXMaxXOffset(PAreaI, PAreaI, int)`
    `static <S> PAreaI<S>` | `alignHorizontallyMinX​(PAreaI<S> outer, PAreaI<S> inner)` | Deprecated. Use `alignOnXMinX(PAreaI, PAreaI)`
    `static <S> PAreaI<S>` | `alignHorizontallyMinXOffset​(PAreaI<S> outer, PAreaI<S> inner, int offset)` | Deprecated. Use `alignOnXMinXOffset(PAreaI, PAreaI, int)`
    `static <S> PAreaI<S>` | `alignMaxYMaxX​(PAreaI<S> outer, PAreaI<S> inner)` | Equivalent to calling `alignMaxYMaxXOffset(PAreaI, PAreaI, int, int)` with zero offsets.
    `static <S> PAreaI<S>` | `alignMaxYMaxXOffset​(PAreaI<S> outer, PAreaI<S> inner, int offset_x, int offset_y)` | Align the area `inner` such that the maximum-y edge is at least `offset_y` from the inside maximum-y edge of `outer` and the maximum-x edge is at least `offset_x` from the inside maximum-x edge of `outer`.
    `static <S> PAreaI<S>` | `alignMaxYMinX​(PAreaI<S> outer, PAreaI<S> inner)` | Equivalent to calling `alignMaxYMinXOffset(PAreaI, PAreaI, int, int)` with zero offsets.
    `static <S> PAreaI<S>` | `alignMaxYMinXOffset​(PAreaI<S> outer, PAreaI<S> inner, int offset_x, int offset_y)` | Align the area `inner` such that the maximum-y edge is at least `offset_y` from the inside maximum-y edge of `outer` and the minimum-x edge is at least `offset_x` from the inside minimum-x edge of `outer`.
    `static <S> PAreaI<S>` | `alignMinYMaxX​(PAreaI<S> outer, PAreaI<S> inner)` | Equivalent to calling `alignMinYMaxXOffset(PAreaI, PAreaI, int, int)` with zero offsets.
    `static <S> PAreaI<S>` | `alignMinYMaxXOffset​(PAreaI<S> outer, PAreaI<S> inner, int offset_x, int offset_y)` | Align the area `inner` such that the minimum-y edge is at least `offset_y` from the inside minimum-y edge of `outer` and the maximum-x edge is at least `offset_x` from the inside maximum-x edge of `outer`.
    `static <S> PAreaI<S>` | `alignMinYMinX​(PAreaI<S> outer, PAreaI<S> inner)` | Equivalent to calling `alignMinYMinXOffset(PAreaI, PAreaI, int, int)` with zero offsets.
    `static <S> PAreaI<S>` | `alignMinYMinXOffset​(PAreaI<S> outer, PAreaI<S> inner, int offset_x, int offset_y)` | Align the area `inner` such that the minimum-y edge is at least `offset_y` from the inside minimum-y edge of `outer` and the minimum-x edge is at least `offset_x` from the inside minimum-x edge of `outer`.
    `static <S> PAreaI<S>` | `alignOnXCenter​(PAreaI<S> outer, PAreaI<S> inner)` | Align the area `inner` along the X axis in the center of `outer`.
    `static <S> PAreaI<S>` | `alignOnXMaxX​(PAreaI<S> outer, PAreaI<S> inner)` | Equivalent to calling `alignOnXMaxXOffset(PAreaI, PAreaI, int)` with a zero offset.
    `static <S> PAreaI<S>` | `alignOnXMaxXOffset​(PAreaI<S> outer, PAreaI<S> inner, int offset)` | Align the area `inner` along the X axis against the inside maximum-x edge of `outer`.
    `static <S> PAreaI<S>` | `alignOnXMinX​(PAreaI<S> outer, PAreaI<S> inner)` | Equivalent to calling `alignOnXMinXOffset(PAreaI, PAreaI, int)` with a zero offset.
    `static <S> PAreaI<S>` | `alignOnXMinXOffset​(PAreaI<S> outer, PAreaI<S> inner, int offset)` | Align the area `inner` along the X axis against the inside minimum-x edge of `outer`.
    `static <S> PAreaI<S>` | `alignOnYCenter​(PAreaI<S> outer, PAreaI<S> inner)` | Align the area `inner` along the Y axis in the center of `outer`.
    `static <S> PAreaI<S>` | `alignOnYMaxY​(PAreaI<S> outer, PAreaI<S> inner)` | Equivalent to calling `alignOnYMaxYOffset(PAreaI, PAreaI, int)` with a zero offset.
    `static <S> PAreaI<S>` | `alignOnYMaxYOffset​(PAreaI<S> outer, PAreaI<S> inner, int offset)` | Align the area `inner` along the Y axis against the inside maximum-y edge of `outer`.
    `static <S> PAreaI<S>` | `alignOnYMinY​(PAreaI<S> outer, PAreaI<S> inner)` | Equivalent to calling `alignOnYMinYOffset(PAreaI, PAreaI, int)` with a zero offset.
    `static <S> PAreaI<S>` | `alignOnYMinYOffset​(PAreaI<S> outer, PAreaI<S> inner, int offset)` | Align the area `inner` along the Y axis against the inside minimum-y edge of `outer`.
    `static <S> PAreaI<S>` | `alignVerticallyCenter​(PAreaI<S> outer, PAreaI<S> inner)` | Deprecated. Use `alignOnYCenter(PAreaI, PAreaI)`
    `static <S> PAreaI<S>` | `alignVerticallyMaxY​(PAreaI<S> outer, PAreaI<S> inner)` | Deprecated. Use `alignOnYMaxY(PAreaI, PAreaI)`
    `static <S> PAreaI<S>` | `alignVerticallyMaxYOffset​(PAreaI<S> outer, PAreaI<S> inner, int offset)` | Deprecated. Use `alignOnYMaxYOffset(PAreaI, PAreaI, int)`
    `static <S> PAreaI<S>` | `alignVerticallyMinY​(PAreaI<S> outer, PAreaI<S> inner)` | Deprecated. Use `alignOnYMinY(PAreaI, PAreaI)`
    `static <S> PAreaI<S>` | `alignVerticallyMinYOffset​(PAreaI<S> outer, PAreaI<S> inner, int offset)` | Deprecated. Use `alignOnYMinYOffset(PAreaI, PAreaI, int)`
    `static <S,T> PAreaI<T>` | `cast​(PAreaI<S> area)` | Brand a given area as belonging to a different coordinate space.
    `static <S> PAreaI<S>` | `containing​(PAreaI<S> a, PAreaI<S> b)` | Construct a area that will contain both `a` and `b`.
    `static <S> boolean` | `contains​(PAreaI<S> a, PAreaI<S> b)` | Determine whether or not one area contains another.
    `static <S> boolean` | `containsPoint​(PAreaI<S> a, int x, int y)` | Determine whether or not a area contains a given point.
    `static <S> boolean` | `couldFitInside​(PAreaI<S> a, PAreaI<S> b)` | Determine whether or not one area could fit inside another.
    `static <S> PAreaI<S>` | `create​(int x, int y, int size_x, int size_y)` | Create an area of size `size_x` on the X axis and size `size_y` on the Y axis, placing the minimum corner at `(x, y)`.
    `static <S> PAreaI<S>` | `fitBetweenHorizontal​(PAreaI<S> fit, PAreaI<S> a, PAreaI<S> b)` | Deprecated. Use `fitBetweenOnX(PAreaI, PAreaI, PAreaI)`
    `static <S> PAreaI<S>` | `fitBetweenOnX​(PAreaI<S> fit, PAreaI<S> a, PAreaI<S> b)` | Attempt to fit `fit` between `a` and `b`, horizontally.
    `static <S> PAreaI<S>` | `fitBetweenOnY​(PAreaI<S> fit, PAreaI<S> a, PAreaI<S> b)` | Attempt to fit `fit` between `a` and `b`, vertically.
    `static <S> PAreaI<S>` | `fitBetweenVertical​(PAreaI<S> fit, PAreaI<S> a, PAreaI<S> b)` | Deprecated. Use `fitBetweenOnY(PAreaI, PAreaI, PAreaI)`
    `static <S> PAreaI<S>` | `hollowOut​(PAreaI<S> outer, int min_x_offset, int max_x_offset, int min_y_offset, int max_y_offset)` | Construct a new area that fits inside `outer` based on the given offsets from each edge.
    `static <S> PAreaI<S>` | `hollowOutEvenly​(PAreaI<S> outer, int offset)` | Equivalent to calling `hollowOut(PAreaI, int, int, int, int)` with `offset` for all offset parameters.
    `static <S> PAreaI<S>` | `moveAbsolute​(PAreaI<S> area, int x, int y)` | Move the given area to `(x, y)`.
    `static <S> PAreaI<S>` | `moveRelative​(PAreaI<S> area, int x, int y)` | Move the given area by `(x, y)`.
    `static <S> PAreaI<S>` | `moveToOrigin​(PAreaI<S> area)` | Move the given area to `(0, 0)`.
    `static <S> boolean` | `overlaps​(PAreaI<S> a, PAreaI<S> b)` | Determine whether or not two areas overlap.
    `static <S> PAreaI<S>` | `scaleFromCenter​(PAreaI<S> area, int x_diff, int y_diff)` | Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY.
    `static <S> PAreaI<S>` | `scaleFromMaxYMaxX​(PAreaI<S> area, int x_diff, int y_diff)` | Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY.
    `static <S> PAreaI<S>` | `scaleFromMaxYMinX​(PAreaI<S> area, int x_diff, int y_diff)` | Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY.
    `static <S> PAreaI<S>` | `scaleFromMinYMaxX​(PAreaI<S> area, int x_diff, int y_diff)` | Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY.
    `static <S> PAreaI<S>` | `scaleFromMinYMinX​(PAreaI<S> area, int x_diff, int y_diff)` | Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY.
    `static <S> PAreaI<S>` | `setSizeFromCenter​(PAreaI<S> area, int sizeX, int sizeY)` | Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.
    `static <S> PAreaI<S>` | `setSizeFromMaxYMaxX​(PAreaI<S> area, int sizeX, int sizeY)` | Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.
    `static <S> PAreaI<S>` | `setSizeFromMaxYMinX​(PAreaI<S> area, int sizeX, int sizeY)` | Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.
    `static <S> PAreaI<S>` | `setSizeFromMinYMaxX​(PAreaI<S> area, int sizeX, int sizeY)` | Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.
    `static <S> PAreaI<S>` | `setSizeFromMinYMinX​(PAreaI<S> area, int sizeX, int sizeY)` | Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.
    `static <S> java.lang.String` | `show​(PAreaI<S> area)` |
    `static <S> java.lang.String` | `showToBuilder​(PAreaI<S> area, java.lang.StringBuilder sb)` |
    `static <S> PAreaSizeI<S>` | `size​(PAreaI<S> area)` |
    `static <S> PAreaXSplitI<S,PAreaI<S>>` | `splitAlongParallelToX​(PAreaI<S> area, int y)` | Split `area` along a line parallel to the X axis placed at `y` units from its own minimum-y edge.
    `static <S> PAreaYSplitI<S,PAreaI<S>>` | `splitAlongParallelToY​(PAreaI<S> area, int x)` | Split `area` along a line parallel to the Y axis placed at `x` units from its own minimum-x edge.
    `static <S> PAreaXYSplitI<S,PAreaI<S>>` | `splitAlongXY​(PAreaI<S> area, int x, int y)` | Split `area` along a two axis-aligned perpendicular lines that intercept at `(x, y)`.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### create

          public static <S> PAreaI<S> create​(int x,
                                             int y,
                                             int size_x,
                                             int size_y)

      Create an area of size `size_x` on the X axis and size `size_y` on the Y axis, placing the minimum corner at `(x, y)`.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `x` - The X value of the minimum corner
        `y` - The Y value of the minimum corner
        `size_x` - The size of the area on the X axis
        `size_y` - The size of the area on the Y axis
      Returns:
        An area

    - #### contains

          public static <S> boolean contains​(PAreaI<S> a,
                                             PAreaI<S> b)

      Determine whether or not one area contains another.

      Containing is reflexive: `contains(a, a) == true`.

      Containing is transitive: `contains(a, b) \u2192 contains(b, c) \u2192 contains(a, c)`.

      Containing is not necessarily symmetric.

      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `a` - Area A
        `b` - Area B
      Returns:
        `true` iff `a` contains `b`

    - #### moveRelative

          public static <S> PAreaI<S> moveRelative​(PAreaI<S> area,
                                                   int x,
                                                   int y)

      Move the given area by `(x, y)`.
      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
        `x` - The amount to move on the X axis
        `y` - The amount to move on the Y axis
      Returns:
        A moved area

    - #### moveAbsolute

          public static <S> PAreaI<S> moveAbsolute​(PAreaI<S> area,
                                                   int x,
                                                   int y)

      Move the given area to `(x, y)`.
      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
        `x` - The position to which to move on the X axis
        `y` - The position to which to move on the Y axis
      Returns:
        A moved area

    - #### moveToOrigin

          public static <S> PAreaI<S> moveToOrigin​(PAreaI<S> area)

      Move the given area to `(0, 0)`.
      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
      Returns:
        A moved area

    - #### cast

          public static <S,T> PAreaI<T> cast​(PAreaI<S> area)

      Brand a given area as belonging to a different coordinate space. Mixing up coordinate spaces is a common source of difficult-to-locate bugs. Use at your own risk.
      Type Parameters:
        `S` - The starting coordinate space
        `T` - The resulting coordinate space
      Parameters:
        `area` - An area
      Returns:
        `area`

    - #### alignHorizontallyCenter

          @Deprecated
          public static <S> PAreaI<S> alignHorizontallyCenter​(PAreaI<S> outer,
                                                              PAreaI<S> inner)

      Deprecated. Use `alignOnXCenter(PAreaI, PAreaI)`
      Align the area `inner` horizontally in the center of `outer`.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignHorizontallyMinX

          @Deprecated
          public static <S> PAreaI<S> alignHorizontallyMinX​(PAreaI<S> outer,
                                                            PAreaI<S> inner)

      Deprecated. Use `alignOnXMinX(PAreaI, PAreaI)`
      Equivalent to calling `alignHorizontallyMinXOffset(PAreaI, PAreaI, int)` with a zero offset.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignHorizontallyMinXOffset

          @Deprecated
          public static <S> PAreaI<S> alignHorizontallyMinXOffset​(PAreaI<S> outer,
                                                                  PAreaI<S> inner,
                                                                  int offset)

      Deprecated. Use `alignOnXMinXOffset(PAreaI, PAreaI, int)`
      Align the area `inner` horizontally against the inside minimum-x edge of `outer`. The area will be at least `offset` units from the minimum-x edge.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area

    - #### alignHorizontallyMaxX

          @Deprecated
          public static <S> PAreaI<S> alignHorizontallyMaxX​(PAreaI<S> outer,
                                                            PAreaI<S> inner)

      Deprecated. Use `alignOnXMaxX(PAreaI, PAreaI)`
      Equivalent to calling `alignHorizontallyMaxXOffset(PAreaI, PAreaI, int)` with a zero offset.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignHorizontallyMaxXOffset

          @Deprecated
          public static <S> PAreaI<S> alignHorizontallyMaxXOffset​(PAreaI<S> outer,
                                                                  PAreaI<S> inner,
                                                                  int offset)

      Deprecated. Use `alignOnXMaxXOffset(PAreaI, PAreaI, int)`
      Align the area `inner` horizontally against the inside maximum-x edge of `outer`. The area will be at least `offset` units from the maximum-x edge.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area

    - #### alignVerticallyMinY

          @Deprecated
          public static <S> PAreaI<S> alignVerticallyMinY​(PAreaI<S> outer,
                                                          PAreaI<S> inner)

      Deprecated. Use `alignOnYMinY(PAreaI, PAreaI)`
      Equivalent to calling `alignVerticallyMinYOffset(PAreaI, PAreaI, int)` with a zero offset.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignVerticallyMinYOffset

          @Deprecated
          public static <S> PAreaI<S> alignVerticallyMinYOffset​(PAreaI<S> outer,
                                                                PAreaI<S> inner,
                                                                int offset)

      Deprecated. Use `alignOnYMinYOffset(PAreaI, PAreaI, int)`
      Align the area `inner` vertically against the inside minimum-y edge of `outer`. The area will be at least `offset` units from the minimum-y edge.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area

    - #### alignVerticallyMaxY

          @Deprecated
          public static <S> PAreaI<S> alignVerticallyMaxY​(PAreaI<S> outer,
                                                          PAreaI<S> inner)

      Deprecated. Use `alignOnYMaxY(PAreaI, PAreaI)`
      Equivalent to calling `alignVerticallyMaxYOffset(PAreaI, PAreaI, int)` with a zero offset.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignVerticallyMaxYOffset

          @Deprecated
          public static <S> PAreaI<S> alignVerticallyMaxYOffset​(PAreaI<S> outer,
                                                                PAreaI<S> inner,
                                                                int offset)

      Deprecated. Use `alignOnYMaxYOffset(PAreaI, PAreaI, int)`
      Align the area `inner` vertically against the inside maximum-y edge of `outer`. The area will be at least `offset` units from the maximum-y edge.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area

    - #### alignVerticallyCenter

          @Deprecated
          public static <S> PAreaI<S> alignVerticallyCenter​(PAreaI<S> outer,
                                                            PAreaI<S> inner)

      Deprecated. Use `alignOnYCenter(PAreaI, PAreaI)`
      Align the area `inner` vertically in the center of `outer`.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignOnXCenter

          public static <S> PAreaI<S> alignOnXCenter​(PAreaI<S> outer,
                                                     PAreaI<S> inner)

      Align the area `inner` along the X axis in the center of `outer`.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnXMinX

          public static <S> PAreaI<S> alignOnXMinX​(PAreaI<S> outer,
                                                   PAreaI<S> inner)

      Equivalent to calling `alignOnXMinXOffset(PAreaI, PAreaI, int)` with a zero offset.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnXMinXOffset

          public static <S> PAreaI<S> alignOnXMinXOffset​(PAreaI<S> outer,
                                                         PAreaI<S> inner,
                                                         int offset)

      Align the area `inner` along the X axis against the inside minimum-x edge of `outer`. The area will be at least `offset` units from the minimum-x edge.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnXMaxX

          public static <S> PAreaI<S> alignOnXMaxX​(PAreaI<S> outer,
                                                   PAreaI<S> inner)

      Equivalent to calling `alignOnXMaxXOffset(PAreaI, PAreaI, int)` with a zero offset.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnXMaxXOffset

          public static <S> PAreaI<S> alignOnXMaxXOffset​(PAreaI<S> outer,
                                                         PAreaI<S> inner,
                                                         int offset)

      Align the area `inner` along the X axis against the inside maximum-x edge of `outer`. The area will be at least `offset` units from the maximum-x edge.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnYMinY

          public static <S> PAreaI<S> alignOnYMinY​(PAreaI<S> outer,
                                                   PAreaI<S> inner)

      Equivalent to calling `alignOnYMinYOffset(PAreaI, PAreaI, int)` with a zero offset.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnYMinYOffset

          public static <S> PAreaI<S> alignOnYMinYOffset​(PAreaI<S> outer,
                                                         PAreaI<S> inner,
                                                         int offset)

      Align the area `inner` along the Y axis against the inside minimum-y edge of `outer`. The area will be at least `offset` units from the minimum-y edge.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnYMaxY

          public static <S> PAreaI<S> alignOnYMaxY​(PAreaI<S> outer,
                                                   PAreaI<S> inner)

      Equivalent to calling `alignOnYMaxYOffset(PAreaI, PAreaI, int)` with a zero offset.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnYMaxYOffset

          public static <S> PAreaI<S> alignOnYMaxYOffset​(PAreaI<S> outer,
                                                         PAreaI<S> inner,
                                                         int offset)

      Align the area `inner` along the Y axis against the inside maximum-y edge of `outer`. The area will be at least `offset` units from the maximum-y edge.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnYCenter

          public static <S> PAreaI<S> alignOnYCenter​(PAreaI<S> outer,
                                                     PAreaI<S> inner)

      Align the area `inner` along the Y axis in the center of `outer`.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignMinYMinX

          public static <S> PAreaI<S> alignMinYMinX​(PAreaI<S> outer,
                                                    PAreaI<S> inner)

      Equivalent to calling `alignMinYMinXOffset(PAreaI, PAreaI, int, int)` with zero offsets.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignMinYMinXOffset

          public static <S> PAreaI<S> alignMinYMinXOffset​(PAreaI<S> outer,
                                                          PAreaI<S> inner,
                                                          int offset_x,
                                                          int offset_y)

      Align the area `inner` such that the minimum-y edge is at least `offset_y` from the inside minimum-y edge of `outer` and the minimum-x edge is at least `offset_x` from the inside minimum-x edge of `outer`.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset_x` - The offset from the minimum-x edge
        `offset_y` - The offset from the minimum-y edge
      Returns:
        An aligned area

    - #### alignMinYMaxX

          public static <S> PAreaI<S> alignMinYMaxX​(PAreaI<S> outer,
                                                    PAreaI<S> inner)

      Equivalent to calling `alignMinYMaxXOffset(PAreaI, PAreaI, int, int)` with zero offsets.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignMinYMaxXOffset

          public static <S> PAreaI<S> alignMinYMaxXOffset​(PAreaI<S> outer,
                                                          PAreaI<S> inner,
                                                          int offset_x,
                                                          int offset_y)

      Align the area `inner` such that the minimum-y edge is at least `offset_y` from the inside minimum-y edge of `outer` and the maximum-x edge is at least `offset_x` from the inside maximum-x edge of `outer`.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset_x` - The offset from the maximum-x edge
        `offset_y` - The offset from the minimum-y edge
      Returns:
        An aligned area

    - #### alignMaxYMinX

          public static <S> PAreaI<S> alignMaxYMinX​(PAreaI<S> outer,
                                                    PAreaI<S> inner)

      Equivalent to calling `alignMaxYMinXOffset(PAreaI, PAreaI, int, int)` with zero offsets.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignMaxYMinXOffset

          public static <S> PAreaI<S> alignMaxYMinXOffset​(PAreaI<S> outer,
                                                          PAreaI<S> inner,
                                                          int offset_x,
                                                          int offset_y)

      Align the area `inner` such that the maximum-y edge is at least `offset_y` from the inside maximum-y edge of `outer` and the minimum-x edge is at least `offset_x` from the inside minimum-x edge of `outer`.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset_x` - The offset from the minimum-x edge
        `offset_y` - The offset from the maximum-y edge
      Returns:
        An aligned area

    - #### alignMaxYMaxX

          public static <S> PAreaI<S> alignMaxYMaxX​(PAreaI<S> outer,
                                                    PAreaI<S> inner)

      Equivalent to calling `alignMaxYMaxXOffset(PAreaI, PAreaI, int, int)` with zero offsets.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignMaxYMaxXOffset

          public static <S> PAreaI<S> alignMaxYMaxXOffset​(PAreaI<S> outer,
                                                          PAreaI<S> inner,
                                                          int offset_x,
                                                          int offset_y)

      Align the area `inner` such that the maximum-y edge is at least `offset_y` from the inside maximum-y edge of `outer` and the maximum-x edge is at least `offset_x` from the inside maximum-x edge of `outer`.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset_x` - The offset from the maximum-x edge
        `offset_y` - The offset from the maximum-y edge
      Returns:
        An aligned area

    - #### alignCenter

          public static <S> PAreaI<S> alignCenter​(PAreaI<S> outer,
                                                  PAreaI<S> inner)

      Align the area `inner` such that the center of the area is equal to the center of `outer`.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### hollowOut

          public static <S> PAreaI<S> hollowOut​(PAreaI<S> outer,
                                                int min_x_offset,
                                                int max_x_offset,
                                                int min_y_offset,
                                                int max_y_offset)

      Construct a new area that fits inside `outer` based on the given offsets from each edge.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The containing area
        `min_x_offset` - The offset from the minimum-x edge (must be non-negative)
        `max_x_offset` - The offset from the maximum-x edge (must be non-negative)
        `min_y_offset` - The offset from the minimum-y edge (must be non-negative)
        `max_y_offset` - The offset from the maximum-y edge (must be non-negative)
      Returns:
        A new area

    - #### hollowOutEvenly

          public static <S> PAreaI<S> hollowOutEvenly​(PAreaI<S> outer,
                                                      int offset)

      Equivalent to calling `hollowOut(PAreaI, int, int, int, int)` with `offset` for all offset parameters.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The containing area
        `offset` - The offset from each edge (must be non-negative)
      Returns:
        A new area

    - #### setSizeFromCenter

          public static <S> PAreaI<S> setSizeFromCenter​(PAreaI<S> area,
                                                        int sizeX,
                                                        int sizeY)

      Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.

      The area is resized from its own center.

      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
        `sizeX` - The new sizeX (must be non-negative)
        `sizeY` - The new sizeY (must be non-negative)
      Returns:
        A resized area

    - #### setSizeFromMinYMinX

          public static <S> PAreaI<S> setSizeFromMinYMinX​(PAreaI<S> area,
                                                          int sizeX,
                                                          int sizeY)

      Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.

      The area is resized by moving its minimum-y-minimum-x corner.

      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
        `sizeX` - The new sizeX (must be non-negative)
        `sizeY` - The new sizeY (must be non-negative)
      Returns:
        A resized area

    - #### setSizeFromMinYMaxX

          public static <S> PAreaI<S> setSizeFromMinYMaxX​(PAreaI<S> area,
                                                          int sizeX,
                                                          int sizeY)

      Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.

      The area is resized by moving its minimum-y-maximum-x corner.

      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
        `sizeX` - The new sizeX (must be non-negative)
        `sizeY` - The new sizeY (must be non-negative)
      Returns:
        A resized area

    - #### setSizeFromMaxYMaxX

          public static <S> PAreaI<S> setSizeFromMaxYMaxX​(PAreaI<S> area,
                                                          int sizeX,
                                                          int sizeY)

      Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.

      The area is resized by moving its maximum-y-maximum-x corner.

      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
        `sizeX` - The new sizeX (must be non-negative)
        `sizeY` - The new sizeY (must be non-negative)
      Returns:
        A resized area

    - #### setSizeFromMaxYMinX

          public static <S> PAreaI<S> setSizeFromMaxYMinX​(PAreaI<S> area,
                                                          int sizeX,
                                                          int sizeY)

      Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.

      The area is resized by moving its maximum-y-minimum-x corner.

      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
        `sizeX` - The new sizeX (must be non-negative)
        `sizeY` - The new sizeY (must be non-negative)
      Returns:
        A resized area

    - #### scaleFromMinYMinX

          public static <S> PAreaI<S> scaleFromMinYMinX​(PAreaI<S> area,
                                                        int x_diff,
                                                        int y_diff)

      Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY. The size of the resulting area is clamped so that its sizeX and sizeY are always non-negative.

      The area is resized by moving its minimum-y-minimum-x corner.

      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
        `x_diff` - The X difference
        `y_diff` - The Y difference
      Returns:
        A resized area

    - #### scaleFromMinYMaxX

          public static <S> PAreaI<S> scaleFromMinYMaxX​(PAreaI<S> area,
                                                        int x_diff,
                                                        int y_diff)

      Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY. The size of the resulting area is clamped so that its sizeX and sizeY are always non-negative.

      The area is resized by moving its minimum-y-maximum-x corner.

      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
        `x_diff` - The X difference
        `y_diff` - The Y difference
      Returns:
        A resized area

    - #### scaleFromMaxYMinX

          public static <S> PAreaI<S> scaleFromMaxYMinX​(PAreaI<S> area,
                                                        int x_diff,
                                                        int y_diff)

      Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY. The size of the resulting area is clamped so that its sizeX and sizeY are always non-negative.

      The area is resized by moving its maximum-y-minimum-x corner.

      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
        `x_diff` - The X difference
        `y_diff` - The Y difference
      Returns:
        A resized area

    - #### scaleFromMaxYMaxX

          public static <S> PAreaI<S> scaleFromMaxYMaxX​(PAreaI<S> area,
                                                        int x_diff,
                                                        int y_diff)

      Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY. The size of the resulting area is clamped so that its sizeX and sizeY are always non-negative.

      The area is resized by moving its maximum-y-maximum-x corner.

      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
        `x_diff` - The X difference
        `y_diff` - The Y difference
      Returns:
        A resized area

    - #### scaleFromCenter

          public static <S> PAreaI<S> scaleFromCenter​(PAreaI<S> area,
                                                      int x_diff,
                                                      int y_diff)

      Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY. The size of the resulting area is clamped so that its sizeX and sizeY are always non-negative.

      The area is resized from its own center.

      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
        `x_diff` - The X difference
        `y_diff` - The Y difference
      Returns:
        A resized area

    - #### overlaps

          public static <S> boolean overlaps​(PAreaI<S> a,
                                             PAreaI<S> b)

      Determine whether or not two areas overlap.

      Overlapping is reflexive: `overlaps(a, a) == true`.

      Overlapping is symmetric: `overlaps(a, b) == overlaps(b, a)`.

      Overlapping is not necessarily transitive.

      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `a` - An area
        `b` - An area
      Returns:
        `true` iff `a` overlaps `b`

    - #### couldFitInside

          public static <S> boolean couldFitInside​(PAreaI<S> a,
                                                   PAreaI<S> b)

      Determine whether or not one area could fit inside another.

      Fitting is reflexive: `couldFitInside(a, a) == true`.

      Fitting is transitive: `couldFitInside(a, b) \u2192 couldFitInside(b, c) \u2192 couldFitInside(a, c)`.

      Fitting is not necessarily symmetric.

      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `a` - An area
        `b` - An area
      Returns:
        `true` iff `a` could fit inside `b`

    - #### containing

          public static <S> PAreaI<S> containing​(PAreaI<S> a,
                                                 PAreaI<S> b)

      Construct a area that will contain both `a` and `b`.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `a` - An area
        `b` - An area
      Returns:
        An area containing `a` and `b`

    - #### containsPoint

          public static <S> boolean containsPoint​(PAreaI<S> a,
                                                  int x,
                                                  int y)

      Determine whether or not a area contains a given point.

      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `a` - An area
        `x` - The X coordinate of the point
        `y` - The Y coordinate of the point
      Returns:
        `true` iff `a` contains `(x, y)`

    - #### fitBetweenHorizontal

          @Deprecated
          public static <S> PAreaI<S> fitBetweenHorizontal​(PAreaI<S> fit,
                                                           PAreaI<S> a,
                                                           PAreaI<S> b)

      Deprecated. Use `fitBetweenOnX(PAreaI, PAreaI, PAreaI)`
      Attempt to fit `fit` between `a` and `b`, horizontally.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `fit` - The area to be fitted
        `a` - An area
        `b` - An area
      Returns:
        A fitted area

    - #### fitBetweenVertical

          @Deprecated
          public static <S> PAreaI<S> fitBetweenVertical​(PAreaI<S> fit,
                                                         PAreaI<S> a,
                                                         PAreaI<S> b)

      Deprecated. Use `fitBetweenOnY(PAreaI, PAreaI, PAreaI)`
      Attempt to fit `fit` between `a` and `b`, vertically.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `fit` - The area to be fitted
        `a` - An area
        `b` - An area
      Returns:
        A fitted area

    - #### fitBetweenOnX

          public static <S> PAreaI<S> fitBetweenOnX​(PAreaI<S> fit,
                                                    PAreaI<S> a,
                                                    PAreaI<S> b)

      Attempt to fit `fit` between `a` and `b`, horizontally.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `fit` - The area to be fitted
        `a` - An area
        `b` - An area
      Returns:
        A fitted area

    - #### fitBetweenOnY

          public static <S> PAreaI<S> fitBetweenOnY​(PAreaI<S> fit,
                                                    PAreaI<S> a,
                                                    PAreaI<S> b)

      Attempt to fit `fit` between `a` and `b`, vertically.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `fit` - The area to be fitted
        `a` - An area
        `b` - An area
      Returns:
        A fitted area

    - #### splitAlongParallelToX

          public static <S> PAreaXSplitI<S,PAreaI<S>> splitAlongParallelToX​(PAreaI<S> area,
                                                                            int y)

      Split `area` along a line parallel to the X axis placed at `y` units from its own minimum-y edge.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `area` - The area to be split
        `y` - The relative Y coordinate of the splitting edge
      Returns:
        A pair of areas

    - #### splitAlongParallelToY

          public static <S> PAreaYSplitI<S,PAreaI<S>> splitAlongParallelToY​(PAreaI<S> area,
                                                                            int x)

      Split `area` along a line parallel to the Y axis placed at `x` units from its own minimum-x edge.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `area` - The area to be split
        `x` - The relative X coordinate of the splitting edge
      Returns:
        A pair of areas

    - #### splitAlongXY

          public static <S> PAreaXYSplitI<S,PAreaI<S>> splitAlongXY​(PAreaI<S> area,
                                                                    int x,
                                                                    int y)

      Split `area` along a two axis-aligned perpendicular lines that intercept at `(x, y)`.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `area` - The area to be split
        `x` - The relative X coordinate of the splitting edge
        `y` - The relative Y coordinate of the splitting edge
      Returns:
        The four resulting quadrants
      Since:
        1.1.0

    - #### show

          public static <S> java.lang.String show​(PAreaI<S> area)

      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
      Returns:
        A terse string describing the position and size of the area

    - #### size

          public static <S> PAreaSizeI<S> size​(PAreaI<S> area)

      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
      Returns:
        The size of the area

    - #### showToBuilder

          public static <S> java.lang.String showToBuilder​(PAreaI<S> area,
                                                           java.lang.StringBuilder sb)

      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
        `sb` - A string builder
      Returns:
        A terse string describing the position and size of the area

Copyright © 2017 <code@io7m.com> http://io7m.com